#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

void solve() {
	int n, m;
	cin >> n >> m;
	swap(n, m);
	vector<vector<char>> a(n + 2, vector<char>(m + 2));
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			cin >> a[i][j];
	
	int dx[4] = {1, 0, -1, 0};
	int dy[4] = {0, 1, 0, -1};
	int dxd[4] = {1, -1, -1, 1};
	int dyd[4] = {1, 1, -1, -1};
	
	vector<vector<char>> key(n + 2, vector<char>(m + 2));
	for (int x = 1; x <= n; ++x)
		for (int y = 1; y <= m; ++y)
			if (a[x][y] == '#') {
				for (int i1 = 0; i1 < 4; ++i1) {
					int i2 = (i1 + 1) % 4;
					int tx1 = x + dx[i1];
					int ty1 = y + dy[i1];
					int tx2 = x + dx[i2];
					int ty2 = y + dy[i2];
					int txd = x + dxd[i1];
					int tyd = y + dyd[i1];
					if (a[tx1][ty1] == '.' && a[tx2][ty2] == '.' && a[txd][tyd] == '.') {
						key[txd][tyd] |= (1 << i1);
						key[txd][tyd] |= (1 << i2);
					}
				}
			}
	
	vector<vector<int>> ansd(n + 2, vector<int>(m + 2)), ansr(n + 2, vector<int>(m + 2)), ansu(n + 2, vector<int>(m + 2)), ansl(n + 2, vector<int>(m + 2));
	
	for (int x = 1; x <= n; ++x) {
		int wy, ky;
		
		wy = 0;
		ky = -1;
		for (int y = 1; y <= m; ++y) {
			if (a[x][y] != '#') {
				if (wy > ky)
					ansl[x][y] = -(y - wy - 1);
				else
					ansl[x][y] = y - ky;
			}
			if (a[x][y] == '#')
				wy = y;
			if (key[x][y] & (1 << 3))
				ky = y;
		}
		
		wy = m + 1;
		ky = m + 2;
		for (int y = m; y >= 1; --y) {
			if (a[x][y] != '#') {
				if (wy < ky)
					ansr[x][y] = -(wy - y - 1);
				else
					ansr[x][y] = ky - y;
			}
			if (a[x][y] == '#')
				wy = y;
			if (key[x][y] & (1 << 1))
				ky = y;
		}
	}
	
	for (int y = 1; y <= m; ++y) {
		int wx, kx;
		
		wx = 0;
		kx = -1;
		for (int x = 1; x <= n; ++x) {
			if (a[x][y] != '#') {
				if (wx > kx)
					ansu[x][y] = -(x - wx - 1);
				else
					ansu[x][y] = x - kx;
			}
			if (a[x][y] == '#')
				wx = x;
			if (key[x][y] & (1 << 2))
				kx = x;
		}
		
		wx = n + 1;
		kx = n + 2;
		for (int x = n; x >= 1; --x) {
			if (a[x][y] != '#') {
				if (wx < kx)
					ansd[x][y] = -(wx - x - 1);
				else
					ansd[x][y] = kx - x;
			}
			if (a[x][y] == '#')
				wx = x;
			if (key[x][y] & (1 << 0))
				kx = x;
		}
	}
	
	vector<vector<string>> ans(3 * (n + 2), vector<string>(3 * (m + 2)));
	for (int x = 1; x <= n; ++x)
		for (int y = 1; y <= m; ++y) {
			if (a[x][y] == '#') {
				for (int i = 0; i < 3; ++i)
					for (int j = 0; j < 3; ++j)
						if ((i + j) % 2 == 0)
							ans[x * 3 + i][y * 3 + j] = "*";
						else
							ans[x * 3 + i][y * 3 + j] = "W";
			}
			else {
				ans[x * 3 + 2][y * 3 + 1] = to_string(ansd[x][y]);
				ans[x * 3 + 1][y * 3 + 2] = to_string(ansr[x][y]);
				ans[x * 3][y * 3 + 1] = to_string(ansu[x][y]);
				ans[x * 3 + 1][y * 3] = to_string(ansl[x][y]);
				for (int i = 0; i < 3; ++i)
					for (int j = 0; j < 3; ++j)
						if ((i + j) % 2 == 0)
							ans[x * 3 + i][y * 3 + j] = "*";
			}
		}
	
	for (int i = 1 * 3; i <= n * 3 + 2; ++i) {
		for (int j = 1 * 3; j <= m * 3 + 2; ++j)
			cout << ans[i][j] << " ";
		cout << endl;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}