#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

void solve() {
	int n;
	cin >> n;
	vector<int> c(n), h(n);
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
		cin >> h[i];
	}
	
	int m;
	cin >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		g[u - 1].push_back({v - 1, w});
		g[v - 1].push_back({u - 1, w});
	}
	
	vector<vector<ll>> dp(1001, vector<ll>(n));
	vector<vector<char>> used(1001, vector<char>(n));
	used[0][0] = 1;
	for (int i = 0; i <= 1000; ++i) {
		for (int u = 0; u < n; ++u) {
			if (used[i][u]) {
				for (auto p : g[u]) {
					int v = p.first;
					int w = p.second;
					if (i + w <= 1000) {
						used[i + w][v] = 1;
						dp[i + w][v] = max(dp[i + w][v], dp[i][u]);
					}
				}
				if (i + 1 <= 1000) {
					used[i + 1][u] = 1;
					dp[i + 1][u] = max(dp[i + 1][u], dp[i][u]);
					if (i < h[u])
						dp[i + 1][u] = max(dp[i + 1][u], dp[i][u] + c[u]);
				}
			}
		}
	}
	
	cout << *max_element(dp[1000].begin(), dp[1000].end()) << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}