#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const ll llinf = 1000000000000000000;
const double eps = 1e-7;
const double pi = acos(-1);

void solve() {
	int f, n;
	cin >> f >> n;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; ++i)
		cin >> a[i];
	int m, c;
	cin >> m >> c;
	vector<vector<int>> rec(m, vector<int>(c + 1));
	for (int i = 0; i < m; ++i)
		for (int j = 0; j < c + 1; ++j)
			cin >> rec[i][j];
	
	vector<vector<int>> pos(n + 1, vector<int>(f + 1));
	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= f; ++j)
			pos[i][j] = pos[i - 1][j];
		pos[i][a[i - 1]] = i - 1;
	}
	
	vector<int> dp(n + 1);
	for (int i = 1; i <= n; ++i) {
		dp[i] = dp[i - 1];
		if (i - c >= 0)
			dp[i] = max(dp[i], dp[i - c] + rec[0][c]);
		for (int j = 1; j < m; ++j)
			if (rec[j][c - 1] == a[i]) {
				int x = i;
				for (int k = c - 2; k >= 0; --k)
					x = pos[x][rec[j][k]];
				if (x > 0)
					dp[i] = max(dp[i], dp[x - 1] + rec[j][c]);
			}
	}
	
	cout << dp[n] << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	
	return 0;
}