import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class Main3 {
    public static void main(String[] args) {
        FastReader in = new FastReader();

        int n = in.nextInt();
        int a = in.nextInt();
        int b = in.nextInt();

        int dif = a - b;

        HashMap<Long, Num> numbers = new HashMap<>();
        for(int k = 0; k < n; k++) {
            int num = in.nextInt();
            for(int i = 0; i <= dif; i++) {
                long newNum = num * (long) Math.pow(2, i);
                if(!numbers.containsKey(newNum)) {
                    numbers.put(newNum, new Num());
                }
                numbers.get(newNum).appearances++;
                numbers.get(newNum).cost += (long) b * i;
            }
        }

        Num maxAppearancesNumber = new Num();
        for(long num : numbers.keySet()) {
            Num number = numbers.get(num);
            if(number.appearances > maxAppearancesNumber.appearances) {
                maxAppearancesNumber = number;
            }
        }

        long result = maxAppearancesNumber.cost + (long) (n - maxAppearancesNumber.appearances) * a;
        System.out.println(result);
    }

    static class Num {
        int appearances;
        long cost;

        public Num() {
            this.appearances = 0;
            this.cost = 0;
        }
    }

    static class FastReader {
        BufferedReader br;
        StringTokenizer st;

        public FastReader() {
            br = new BufferedReader(new
                    InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }
}
