#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

typedef double ld;

const double eps = 1e-8;
const ll INFll = 1e18;
const ll INFi = 1e9 + 63;
const ll mod = 1e9 + 7;
const int maxn = 55;
const int maxd = 6;

const double pi =acos(-1);

int caseNo = 1;

int mapa[maxn][maxn];

int enterDirs[maxn][maxn][maxd];
int nearest[maxn][maxn][maxd];

char result[3*maxn][3*maxn];
int resultNums[3*maxn][3*maxn];
int w,h;

int getMapa(int i, int j) {
    if (i<0 || i>maxn || j<0 || j>maxn) return 1;
    return mapa[i][j];
}
void checkDir(pair<int,int> dirDiag, pair<int,int> dirOpp1, pair<int,int> dirOpp2, int dirId, int dirId2) {
    for (int i=0;i<h;i++) {
        for (int j=0;j<w;j++) {
            if (getMapa(i,j)
            && !getMapa(i+dirDiag.first,j+dirDiag.second)
            && !getMapa(i+dirOpp1.first,j+dirOpp1.second)
            && !getMapa(i+dirOpp2.first,j+dirOpp2.second)) {
                enterDirs[i+dirDiag.first][j+dirDiag.second][dirId] =
                enterDirs[i+dirDiag.first][j+dirDiag.second][dirId2] = 1;
//                cout << "enterDirs[" << i+dirDiag.first << "][" << j+dirDiag.second << "]: " << dirId << ", " << dirId2 << endl;
            }

        }
    }
}

void findNearest(int r, int c, int dir) {
    pair<int,int> vec;
    if (dir==1) {
        vec = {0, 1};
    }
    if (dir==2) {
        vec = {1, 0};
    }
    if (dir==3) {
        vec = {0, -1};
    }
    if (dir==4) {
        vec = {-1, 0};
    }
    int dist = 0;
    int curR = r+vec.first;
    int curC = c+vec.second;
    while (true) {
        if (mapa[curR][curC]) {
            nearest[r][c][dir] = -dist;
            return;
        }
        if (enterDirs[curR][curC][dir]) {
            nearest[r][c][dir] = dist+1;
            return;
        }
        dist++;
        curR += vec.first;
        curC += vec.second;
    }
}
void solve() {
    cin >> w >> h;
    for (int i=0;i<h+2;i++) {
        for (int j=0;j<w+2;j++) {
            mapa[i][j] = 1;
        }
    }
    for (int i=0;i<h;i++) {
        string s;
        cin >> s;
        for (int j=0;j<w;j++) {
            mapa[i+1][j+1] = s[j]=='#' ? 1 : 0;
        }
    }
    w+=2;
    h+=2;

    checkDir({1,1}, {0, 1}, {1, 0}, 1, 2);
    checkDir({-1,1}, {0, 1}, {-1, 0}, 1, 4);
    checkDir({1,-1}, {0, -1}, {1, 0}, 3, 2);
    checkDir({-1,-1}, {0, -1}, {-1, 0}, 3, 4);

    for (int i=1;i+1<h;i++) {
        for (int j = 1; j + 1 < w; j++) {
            if (mapa[i][j]) continue;
            for (int k=1;k<=4;k++) {
                findNearest(i,j,k);
            }
        }
    }

    for (int i=1;i+1<h;i++) {
        for (int j = 1; j + 1 < w; j++) {
            int i_ = i-1;
            int j_ = j-1;
            result[3*i_][3*j_] = '*';
            result[3*i_+1][3*j_+1] = '*';
            result[3*i_+2][3*j_] = '*';
            result[3*i_][3*j_+2] = '*';
            result[3*i_+2][3*j_+2] = '*';
            if (mapa[i][j]) {
                result[3*i_][3*j_+1] = 'W';
                result[3*i_+1][3*j_] = 'W';
                result[3*i_+1][3*j_+2] = 'W';
                result[3*i_+2][3*j_+1] = 'W';
            } else {
                result[3*i_][3*j_+1] = 'N';
                result[3*i_+1][3*j_] = 'N';
                result[3*i_+1][3*j_+2] = 'N';
                result[3*i_+2][3*j_+1] = 'N';
                resultNums[3*i_][3*j_+1] = nearest[i][j][4];
                resultNums[3*i_+1][3*j_] = nearest[i][j][3];
                resultNums[3*i_+1][3*j_+2] = nearest[i][j][1];
                resultNums[3*i_+2][3*j_+1] = nearest[i][j][2];
            }
        }
    }

    for (int i=0;i<3*h;i++) {
        for (int j=0;j<3*w;j++) {
            if (result[i][j] != 'N') {
                cout << result[i][j] << " ";
            } else {
                cout << resultNums[i][j] << " ";
            }
        }
        cout << "\n";
    }
}

int main(int argc, char** argv) {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    cout << setprecision(15) << fixed;
   // freopen("input.txt","r",stdin);
//    precalc();
    int t = 1;
//    cin >> t;
    for (int i=0;i<t;i++)
//    while (1)
        solve();

    return 0;
}
