#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

const int MAXX = 1100;

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<vector<int>>> dist(MAXX, vector<vector<int>>(MAXX, vector<int>(2, inf)));
    dist[MAXX / 2][MAXX / 2][0] = dist[MAXX / 2][MAXX / 2][1] = 0;
    queue<tuple<int, int, int>> q;

    q.push({MAXX / 2, MAXX / 2, 0});
    q.push({MAXX / 2, MAXX / 2, 1});

    while (!q.empty()) {
        auto [i, j, last] = q.front();
        q.pop();
//        cout << i << " " << j << " " << last << endl;
        vector<tuple<int, int, int>> tos;
        if (last == 0) {
            for (int dj = -1; dj <= 1; dj += 2) {
                int ti = i;
                int tj = j + dj;
                tos.emplace_back(ti, tj, 1);
            }
        } else {
            for (int di = -1; di <= 1; di += 2) {
                int ti = i + di;
                int tj = j;
                tos.emplace_back(ti, tj, 0);
            }
        }
        for (auto [ti, tj, tlast] : tos) {
            if (0 <= ti && ti < MAXX && 0 <= tj && tj < MAXX && dist[ti][tj][tlast] > dist[i][j][last] + 1) {
                dist[ti][tj][tlast] = dist[i][j][last] + 1;
                q.push({ti, tj, tlast});
            }
        }
    }

    int res = 0;
    for (int i = 0; i < MAXX; i++) {
        for (int j = 0; j < MAXX; j++) {
            if (dist[i][j][0] <= n || dist[i][j][1] <= n)
                res++;
        }
    }

    cout << res << "\n";

    return 0;
}
