#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;

    vector<string> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    vector<vector<int>> fL(n, vector<int>(m)), fR = fL, fU = fL, fD = fL;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#')
                continue;
            if (i > 0 && j > 0 && a[i - 1][j - 1] == '#' && a[i - 1][j] == '.' && a[i][j - 1] == '.')
                fL[i][j] = fU[i][j] = 1;
            if (i > 0 && j + 1 < m && a[i - 1][j + 1] == '#' && a[i - 1][j] == '.' && a[i][j + 1] == '.')
                fR[i][j] = fU[i][j] = 1;
            if (i + 1 < n && j > 0 && a[i + 1][j - 1] == '#' && a[i][j - 1] == '.' && a[i + 1][j] == '.')
                fL[i][j] = fD[i][j] = 1;
            if (i + 1 < n && j + 1 < m && a[i + 1][j + 1] == '#' && a[i][j + 1] == '.' && a[i + 1][j] == '.')
                fR[i][j] = fD[i][j] = 1;
        }
    }

    vector<vector<int>> L(n, vector<int>(m)), R = L, U = L, D = L;

    for (int i = 0; i < n; i++) {
        int last = -1;
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#') {
                last = j;
                continue;
            }
            L[i][j] = last;
            if (fR[i][j])
                last = j;
        }
        last = m;
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == '#') {
                last = j;
                continue;
            }
            R[i][j] = last;
            if (fL[i][j])
                last = j;
        }
    }

    for (int j = 0; j < m; j++) {
        int last = -1;
        for (int i = 0; i < n; i++) {
            if (a[i][j] == '#') {
                last = i;
                continue;
            }
            U[i][j] = last;
            if (fD[i][j])
                last = i;
        }
        last = n;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i][j] == '#') {
                last = i;
                continue;
            }
            D[i][j] = last;
            if (fU[i][j])
                last = i;
        }
    }

    vector<vector<int>> res(3 * n, vector<int>(3 * m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '#') {
                res[3 * i][3 * j + 1] = res[3 * i + 1][3 * j] = 'W';
                res[3 * i + 1][3 * j + 2] = res[3 * i + 2][3 * j + 1] = 'W';
            } else {
                int dist;

                // U
                dist = i - U[i][j];
                res[3 * i][3 * j + 1] = dist + '0';
            }
        }
    }

    for (int i = 0; i < 3 * n; i++) {
        for (int j = 0; j < 3 * m; j++) {
            if ((i % 3 == 0 && j % 3 == 0) ||
                (i % 3 == 0 && j % 3 == 2) ||
                (i % 3 == 2 && j % 3 == 0) ||
                (i % 3 == 2 && j % 3 == 2) ||
                (i % 3 == 1 && j % 3 == 1)) {
                cout << '*';
            } else {
                int p = i / 3;
                int q = j / 3;
                if (a[p][q] == '#') {
                    cout << 'W';
                } else {
                    if (i % 3 == 0 && j % 3 == 1) { // U
                        if (U[p][q] < 0 || a[U[p][q]][q] == '#') {
                            cout << -(p - U[p][q] - 1);
                        } else {
                            cout << (p - U[p][q]);
                        }
                    } else if (i % 3 == 1 && j % 3 == 0) { // L
                        if (L[p][q] < 0 || a[p][L[p][q]] == '#') {
                            cout << -(q - L[p][q] - 1);
                        } else {
                            cout << (q - L[p][q]);
                        }
                    } else if (i % 3 == 1 && j % 3 == 2) { // R
                        if (R[p][q] >= m || a[p][R[p][q]] == '#') {
                            cout << -(R[p][q] - q - 1);
                        } else {
                            cout << (R[p][q] - q);
                        }
                    } else { // D
                        if (D[p][q] >= n || a[D[p][q]][q] == '#') {
                            cout << -(D[p][q] - p - 1);
                        } else {
                            cout << (D[p][q] - p);
                        }
                    }
                }
            }
            cout << ' ';
        }
        cout << '\n';
    }

    return 0;
}
