#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

const int MAXT = 1010;

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> c(n + 1), h(n + 1);

    for (int i = 1; i <= n; i++) {
        cin >> c[i] >> h[i];
    }

    int m;
    cin >> m;
    vector<tuple<int, int, int>> edges(m);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        edges[i] = {u, v, w};
    }

    vector<vector<ll>> dp(n + 1, vector<ll>(MAXT, -inf64));
    dp[1][0] = 0;

    for (int t = 0; t < MAXT; t++) {
        if (t + 1 < MAXT) {
            for (int v = 1; v <= n; v++) {
                dp[v][t + 1] = max(dp[v][t + 1], dp[v][t]);
                if (t < h[v])
                    dp[v][t + 1] = max(dp[v][t + 1], dp[v][t] + c[v]);
            }
        }
        for (auto [u, v, w] : edges) {
            if (t + w < MAXT) {
                dp[v][t + w] = max(dp[v][t + w], dp[u][t]);
                dp[u][t + w] = max(dp[u][t + w], dp[v][t]);
            }
        }
    }

    ll res = 0;
    for (int v = 1; v <= n; v++)
        res = max(res, dp[v][MAXT - 1]);

    cout << res << "\n";

    return 0;
}
