#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int inf = 1e9;
const ll inf64 = 1e18;

int slow(int f, int n, vector<int> a, int m, int C, vector<vector<int>> seq, vector<int> d) {
    int res = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> cur;
        int score = 0;
        for (int i = 0; i < n; i++) {
            if ((1 << i) & mask) {
                cur.push_back(a[i]);
                if ((int) cur.size() == C) {
                    int j = -1;
                    for (int q = 1; q < m; q++) {
                        if (cur == seq[q]) {
                            if (j == -1 || d[j] < d[q])
                                j = q;
                        }
                    }
                    if (j == -1) j = 0;
                    score += d[j];
                    cur.clear();
                }
            }
        }
        if (cur.empty())
            res = max(res, score);
    }
    return res;
}

int fast(int f, int n, vector<int> a, int m, int C, vector<vector<int>> seq, vector<int> d) {
    if (n == 0) return 0;

    struct Node {
        vector<int> nxt;
        int value = -1000;
        int depth = 0;

        Node(int f) {
            nxt.assign(f + 1, -1);
        }
    };
    vector<Node> t = {Node(f)};

    for (int j = 1; j < m; j++) {
        int v = 0;
        for (int q = 0; q < C; q++) {
            int elem = seq[j][q];
            if (t[v].nxt[elem] == -1) {
                t[v].nxt[elem] = (int) t.size();
                t.push_back(Node(f));
            }
            v = t[v].nxt[elem];
            t[v].depth = q + 1;
        }
        t[v].value = max(t[v].value, d[j]);
    }

//    cout << "\n";
//    for (int v = 0; v < (int) t.size(); v++) {
//        for (int c = 1; c <= f; c++) {
//            if (t[v].nxt[c] != -1)
//                cout << v << " " << t[v].nxt[c] << " " << c << "\n";
//        }
//    }
//    cout << "\n";

    int S = (int) t.size() + C - 1;
    vector<vector<int>> dp(n + 1, vector<int>(S, -inf));
    dp[0][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int s = 0; s < S; s++) {
            if (dp[i][s] == -inf)
                continue;
            dp[i + 1][s] = max(dp[i + 1][s], dp[i][s]);
            if (s < (int) t.size()) {
                int to = t[s].nxt[a[i]];
                if (to == -1) {
                    if (t[s].depth + 1 >= C) {
                        dp[i + 1][0] = max(dp[i + 1][0], dp[i][s] + d[0]);
                    } else {
                        int ns = (int) t.size() + t[s].depth + 1 - 1;
                        dp[i + 1][ns] = max(dp[i + 1][ns], dp[i][s]);
                    }
                } else {
                    if (t[s].depth + 1 == C) {
                        dp[i + 1][0] = max(dp[i + 1][0], dp[i][s] + t[to].value);
                    } else {
                        dp[i + 1][to] = max(dp[i + 1][to], dp[i][s]);
                    }
                }
            } else {
                int depth = s - (int) t.size() + 1;
                if (depth + 1 >= C) {
                    dp[i + 1][0] = max(dp[i + 1][0], dp[i][s] + d[0]);
                } else {
                    dp[i + 1][s + 1] = max(dp[i + 1][s + 1], dp[i][s]);
                }
            }
        }
    }
//    cout << dp[4][0] << "\n";
    return dp[n][0];
}

void work() {
    int f;
    cin >> f;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int m, C;
    cin >> m >> C;
    vector<vector<int>> seq(m, vector<int>(C));
    vector<int> d(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < C; j++) {
            cin >> seq[i][j];
        }
        cin >> d[i];
    }
    int fs = fast(f, n, a, m, C, seq, d);
    cout << fs << "\n";
}

void test() {
    mt19937 rnd(42);
    const int MAXN = 6;
    const int MAXM = 5;
    const int MAXF = 2;
    const int MAXX = 100;
    while (1) {
        int f = rnd() % MAXF + 1;
        int n = rnd() % MAXN;
        vector<int> a(n);
        for (int i = 0; i < n; i++)
            a[i] = rnd() % f + 1;
        int m = rnd() % MAXM + 1;
        int C = rnd() % MAXN + 1;
        vector<vector<int>> seq(m, vector<int>(C));
        vector<int> d(m);
        for (int j = 0; j < m; j++) {
            if (j > 0) {
                for (int q = 0; q < C; q++) {
                    seq[j][q] = rnd() % f + 1;
                }
            }
            d[j] = rnd() % (2 * MAXX + 1) - MAXX;
        }
        int fs = fast(f, n, a, m, C, seq, d);
        int sl = slow(f, n, a, m, C, seq, d);
        if (fs == sl) {
            cout << "OK(" << fs << ")" << endl;
        } else {
            cout << "WA\n";
            cout << "exp = " << sl << "\n";
            cout << "fnd = " << fs << "\n";
            cout << f << "\n";
            cout << n << "\n";
            for (int i = 0; i < n; i++)
                cout << a[i] << " ";
            cout << "\n";
            cout << m << " " << C << "\n";
            for (int j = 0; j < m; j++) {
                for (int q = 0; q < C; q++)
                    cout << seq[j][q] << " ";
                cout << d[j] << "\n";
            }
            break;
        }
    }
}

int main() {

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    work();
//    test();

    return 0;
}
