#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <cmath>

using namespace std;
typedef long long ll;

struct Field {
    bool isK = false;
    bool isW = false;
    int l, r, u, d;

    void print() {

    }
};

int w, h;
vector<vector<Field>> mp;

struct Vec {
    int x, y;

    Vec operator+(Vec b) {
        return {x + b.x, y + b.y};
    }


};

void handle(Vec dir) {
    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= w; j++)
            if (mp[i][j].isW) {
                Vec nb = Vec{j, i} + dir;
                if (mp[nb.y][nb.x].isW == false && (!mp[nb.y][j].isW && !mp[i][nb.x].isW)) {
                    mp[nb.y][nb.x].isK = true;
                }
            }
}

int near(Vec cur, Vec dir) {
    int res = 0;
    while (cur.x >= 0 && cur.x <= w + 1 || cur.y >= 0 && cur.y <= h + 1) {
        cur = cur + dir;
        if (mp[cur.y][cur.x].isW)
            return -res;
        if (mp[cur.y][cur.x].isK)
            return res + 1;
        res++;
    }
}

int main() {
    cin >> w >> h;
    mp.resize(h + 2, vector<Field>(w + 2));
    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= w; j++) {
            char ch;
            cin >> ch;
            if (ch == '#')
                mp[i][j].isW = true;
        }
    for (int i = 0; i <= h + 1; i++) {
        mp[i][0].isW = true;
        mp[i][w + 1].isW = true;
    }
    for (int i = 0; i <= w + 1; i++) {
        mp[0][i].isW = true;
        mp[h + 1][i].isW = true;
    }

    handle({1, 1});
    handle({-1, 1});
    handle({1, -1});
    handle({-1, -1});

    for (int i = 1; i <= h; i++)
        for (int j = 1; j <= w; j++) {
            mp[i][j].l = near({j, i}, {-1, 0});
            mp[i][j].r = near({j, i}, {1, 0});
            mp[i][j].u = near({j, i}, {0, -1});
            mp[i][j].d = near({j, i}, {0, 1});
        }
    vector<vector<int>> m(3 * h, vector<int>(3 * w));

    for (int i = 0; i < h * 3; i += 3)
        for (int j = 0; j < w * 3; j += 3) {
            m[i][j] = m[i][j + 2] = m[i + 1][j + 1] = m[i + 2][j] = m[i + 2][j + 2] = 100000;
            if (mp[i / 3 + 1][j / 3 + 1].isW)
                m[i][j + 1] = m[i + 1][j] = m[i + 1][j + 2] = m[i + 2][j + 1] = 100001;
            else {
                m[i][j + 1] = mp[i / 3 + 1][j / 3 + 1].u;
                m[i + 1][j] = mp[i / 3 + 1][j / 3 + 1].l;
                m[i + 1][j + 2] = mp[i / 3 + 1][j / 3 + 1].r;
                m[i + 2][j + 1] = mp[i / 3 + 1][j / 3 + 1].d;
            }

        }
    for (int i = 0; i < h * 3; i++) {
        for (int j = 0; j < w * 3; j++)
            if (m[i][j] == 100000)
                cout << '*';
            else if (m[i][j] == 100001)
                cout << 'W';
            else
                cout << m[i][j];
        cout << endl;
    }
}
